/*
 * gfx_rend.h
 */

{
unsigned        hscroll, hscroll_ntab, hscroll_mask, vscroll, vscroll_ntab,
                scroll_width, scroll_height, column, tile_line;
unsigned char   *nametab, *video;

scroll_width = ((vdp.reg[16] & 3) + 1) << 5;
scroll_height = (((vdp.reg[16] >> 4) & 3) + 1) << 5;

switch (vdp.reg[11] & 3)        /* hscroll mode */
{
        case 0:                 /* full scroll */
        #if SCROLL == 0
                hscroll = ~(GetWord(vdp.hscroll_addr)) + 1;
        #else
                hscroll = ~(GetWord(vdp.hscroll_addr + 2)) + 1;
        #endif
                break;
        case 1:                 /* prohibited */
                hscroll = 0;
                break;
        case 2:                 /* each one cell */
        #if SCROLL == 0
                hscroll = ~(GetWord(vdp.hscroll_addr + ((line & 0xff8) << 2)))
                           + 1;
        #else
                hscroll = ~(GetWord(vdp.hscroll_addr+2+((line & 0xff8) << 2)))
                           + 1;
        #endif
                break;
        case 3:                 /* each one line */
        #if SCROLL == 0
                hscroll = ~(GetWord(vdp.hscroll_addr + (line << 2))) + 1;
        #else
                hscroll = ~(GetWord(vdp.hscroll_addr + (line << 2) + 2)) + 1;
        #endif
                break;
        default:                /* this will never happen... */
                break;
}

if (!(vdp.reg[11] & 4))         /* if full vscroll ... */
{
#if SCROLL == 0
        vscroll = GetWord(vdp.vsram);
#else
        vscroll = GetWord(vdp.vsram + 2);
#endif
}
else
        vscroll = vscroll_ntab = 0;

hscroll &= 0x3ff;
vscroll &= 0x7ff;
vscroll += line;
hscroll_mask = (scroll_width << 1) - 1;
hscroll_ntab = ((hscroll >> 3) << 1) & hscroll_mask;
vscroll_ntab = ((vscroll >> 3) & (scroll_height - 1)) << 1;

#if SCROLL == 0
nametab = (scroll_width * vscroll_ntab) + vdp.scroll_a_addr;
#else
nametab = (scroll_width * vscroll_ntab) + vdp.scroll_b_addr;
#endif

video = (line * ((BUFFER_CELL_WIDTH) << 3)) + video_buffer - (hscroll & 7);

tile_line = vscroll & 7;        /* don't modify actual line variable */

for (column = 0; column < 41; column++)
{                
        if (vdp.reg[11] & 4)    /* each 2 cell */
        {
        #if SCROLL == 0
                if (column > 39)        /* prevents problems when hscrolled */
                        vscroll = GetWord(vdp.vsram);
                else
                        vscroll = GetWord(vdp.vsram + ((column / 2) * 4));
        #else
                if (column > 39)
                        vscroll = GetWord(vdp.vsram + 2);
                else
                        vscroll = GetWord(vdp.vsram + ((column / 2) * 4) + 2);
        #endif
                vscroll &= 0x7ff;
                vscroll += line;
                vscroll_ntab = ((vscroll >> 3) & (scroll_height - 1)) << 1;
        #if SCROLL == 0
                nametab = (scroll_width * vscroll_ntab) + vdp.scroll_a_addr;
        #else
                nametab = (scroll_width * vscroll_ntab) + vdp.scroll_b_addr;
        #endif
                video = (line * ((BUFFER_CELL_WIDTH) << 3)) + video_buffer
                        - (hscroll & 7) + (column)*8;
                tile_line = vscroll & 7;
        }      
                               
#if (PRI == 0) && (SOLID == 0)
        DrawTile(tile_line, nametab + hscroll_ntab, video);
#elif (PRI == 0) && (SOLID == 1)
        DrawTileSolid(tile_line, nametab + hscroll_ntab, video);
#elif (PRI == 1) && (SOLID == 1) && (SCROLL == 1)
        DrawTileSolid(tile_line, nametab + hscroll_ntab, video);
#elif (PRI == 1) && (SOLID == 0)
        if (GetWord(nametab + hscroll_ntab) >> 15)
                DrawTile(tile_line, nametab + hscroll_ntab, video);
#else
        if (!(GetWord(nametab + hscroll_ntab) >> 15))
                DrawTile(tile_line, nametab + hscroll_ntab, video);
#endif
        hscroll_ntab = (hscroll_ntab + 2) & hscroll_mask;
        video += 8;
}
}



