/*
 * vdp.h: Access to VDP context and emulation functions
 */

struct vdp_struct
{
        unsigned char                   *vram;
        unsigned char                   *cram;
        unsigned char                   *vsram;

        int                             ctrlport_mode;
        int                             access_mode;
        unsigned int                    addr;        
        int                             dma_mode;

        unsigned int                    control_port;
        unsigned int                    status_register;
        unsigned int                    hv_counter;

        unsigned int                    reg[24];
        unsigned char                   *scroll_a_addr;
        unsigned char                   *scroll_b_addr;
        unsigned char                   *window_addr;
        unsigned char                   *sprite_addr;
        unsigned char                   *hscroll_addr;
       
        unsigned                        window_x;
        unsigned                        window_y;
        unsigned                        window_width;
        unsigned                        window_height;
        unsigned                        sprite_order[80];
        unsigned                        sprite_count;
        int                             hint_timer;
};
extern struct vdp_struct                vdp;

/* vdp.c */
void                                    VDPUpdateHVCounter(unsigned);
void                                    VDPVBlankStart();
void                                    VDPVBlankEnd();
void                                    VDPArmHIntTimer();
void                                    VDPHInterrupt();
void                                    VDPInit();
void                                    VDPDeinit();
void                                    VDPSetReg(int, unsigned);
void                                    VDPWriteByte(unsigned, unsigned);
void                                    VDPWriteWord(unsigned, unsigned);
unsigned                                VDPReadByte(unsigned);
unsigned                                VDPReadWord(unsigned);
void                                    VDPCalcSpriteOrder(int);

